#include "ducks.h"

//define array of function pointers 
//and assign pointers to the functions in the same order as enums
void (*fly_behaviors[])() = {fly_wings, fly_rocket, no_fly};
void (*quack_behaviors[])() = {squeak, mute_quack, quack};

int main () {
    int i;
    
    Duck ducks [4];
    ducks[0].name = "Mallard";
    ducks[0].fly_type = FLY_WINGS;
    ducks[0].quack_type = QUACK;
    
    ducks[1].name = "Domestic";
    ducks[1].fly_type = NO_FLY;
    ducks[1].quack_type = QUACK;
    
    ducks[2].name = "Rubber";
    ducks[2].fly_type = NO_FLY;
    ducks[2].quack_type = SQUEACK;
    
    ducks[3].name = "Wooden";
    ducks[3].fly_type = NO_FLY;
    ducks[3].quack_type = SILENCE;
    
    for (i=0; i< 4; i++){
        simulate_duck (&ducks[i]);
    }    
    
    return 0;
}

void simulate_duck (Duck * duck){     
    printf ("\nI am a %s Duck\n", duck->name);
    fly_behaviors [duck->fly_type] ();
    quack_behaviors [duck->quack_type] ();
}

//quack behaviours
void quack () {
    puts ("Quack quack");
}

void squeak () {
    puts ("Squeak");
}

void mute_quack () {
    puts ("<<Silence>>");
}

//fly behaviours
void fly_wings () {
    puts ("I am flying with the wings!");
}

void no_fly () {
    puts ("I cannot fly...");
}

void fly_rocket () {
    puts ("I am flying with the rocket!!");
}